Bumped revision number
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=2.3
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # See the README file for information about the dependencies
19 # this script has.
20
21 ##############################################################################################
22 # Global Variables
23 ##############################################################################################
24 typeset cmd="$0 $*"
25 typeset dvdname=""
26 typeset debug=""
27 typeset dest=""
28 typeset isofile=""
29 typeset vobfile=""
30 typeset dvdpath=""
31 typeset aspect=""
32 typeset SCALE=""
33 typeset CROP=""
34 typeset profile="xvidhq"
35 typeset extension=""
36 typeset mailto=""
37 typeset encoder=""
38 typeset default_alang="en"
39 typeset track=""
40 typeset drc="0.0"
41 typeset -i default_aid=128
42 typeset -i aid_override=-1
43 typeset -i force_onepass_mode=0
44 typeset -i eject_disk=1
45 typeset -i keep_isofile=0
46 typeset -i keep_vobfile=0
47 typeset -i keep_dvdfolder=0
48 typeset -i keep_intermediate_files=0
49 typeset -i make_final_dest_vob=0
50 typeset -i make_final_dest_iso=0
51 typeset -i make_final_dest_folder=0
52 typeset -i make_final_dest_comp=0
53 typeset -i errors=0
54 typeset -i show_usage=0
55 typeset -i mirror_mode=0
56 typeset -i target_bitrate=2000
57 typeset -i target_size=0
58 typeset -i audio_2ch=0
59 typeset -i audio_6ch=1
60 typeset -i invalid_feature_title=0
61 typeset -i feature_title_override=0
62 typeset -i mplayer_dumpstream_incompatibility=0
63 typeset -i custom_bitrate=0
64 typeset -i custom_audio_2ch=0
65 typeset -i custom_audio_6ch=0
66
67 ##############################################################################
68 # Local Machine Settings:
69 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
70 # and the local conf file created by each local machine (rip_dvd.conf)
71 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
72 # This will allow you to override all the default values to meet your needs
73 # in a way that won't get clobbered when you pull updates from my GIT repo.
74 ##############################################################################
75 config="${0%/*}/rip_dvd.conf"
76
77 # The config file will be searched for in the following location order:
78 found_config=0
79
80 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
81 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
82
83 # 2) /path/to/rip_dvd/script/rip_dvd.conf
84 [ -e "${config}" ] && found_config=1 && . "${config}"
85
86 # 3) /etc/rip_dvd.conf
87 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
88
89 # 4) $PWD/rip_dvd.conf
90 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
91
92 # Check to make sure we found the config file
93 if [ $found_config -eq 0 ]; then
94   echo "-E- Unable to find the rip_dvd.conf file: $config"
95   exit 1
96 fi
97
98 ##############################################################################################
99 # Command line processing
100 ##############################################################################################
101 while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
102 do
103     case $opt in
104         (n)     dvdname=$OPTARG;;
105         (d)     dest=$OPTARG;;
106         (b)     target_bitrate=$OPTARG; custom_bitrate=1;;
107         (s)     target_size=$OPTARG;;
108         (2)     audio_2ch=1; custom_audio_2ch=1;;
109         (6)     audio_6ch=1; custom_audio_6ch=1;;
110         (1)     force_onepass_mode=1;;
111         (v)     make_final_dest_vob=1;;
112         (i)     make_final_dest_iso=1;;
113         (f)     make_final_dest_folder=1;; 
114         (z)     make_final_dest_comp=1;;
115         (e)     encoder=$OPTARG;;
116         (m)     mirror_mode=1;;
117         (k)     keep_intermediate_files=1;;
118         (t)     feature_title_override=$OPTARG;;
119         (a)     aspect=$OPTARG;;
120         (p)     profile=$OPTARG;;
121         (x)     extension=$OPTARG;;
122         (j)     eject_disk=$OPTARG;;
123         (l)     aid_override=$OPTARG;;
124         (r)     drc=$OPTARG;;
125         (w)     set -x;;
126         (h)     show_usage=1;;
127         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
128         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
129     esac
130 done
131
132 shift $((OPTIND-1))
133
134 function usage() {
135     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
136     echo >&2 "Revision $REV"
137     echo >&2 "Options:"
138     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
139     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
140     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
141     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
142     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
143     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
144     echo >&2 "                 5) If dvdname is a full path to a VOB file, it will be ripped as a DVD instead of $dev"
145     echo >&2 "   -p <profile>  Specify which encoding profile to use in -w mode as shown below:"
146     echo >&2 "                 Mencoder and Handbrake Encoder Profiles:"
147     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding"
148     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding (default)"
149     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
150     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
151     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
152     echo >&2 "                 Handbrake Only Encoder Profiles:"
153     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
154     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
155     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
156     echo >&2 "                 - hb_<profile> = Any predefined HandBrake profile (run HandBrakeCLI -z and replace spaces with underscores) "
157     echo >&2 "   -x <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
158     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
159     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
160     echo >&2 "                 The default operation is non-mirror mode where only the main"
161     echo >&2 "                 feature title will be ripped."
162     echo >&2 "   -v            Make the final image a DVD VOB file"
163     echo >&2 "   -i            Make the final image a DVD ISO file"
164     echo >&2 "   -f            Make the final image a DVD folder"
165     echo >&2 "   -z            Make the final image a compressed file based on your profile selection and encoder"
166     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
167     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
168     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
169     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
170     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
171     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
172     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
173     echo >&2 "   -j <n>        Eject the disk:"
174     echo >&2 "                 - 0 = do not eject the disk"
175     echo >&2 "                 - 1 = eject after the entire script is done (default)"
176     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
177     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
178     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
179     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
180     echo >&2 "   -6            Use 6 channel AC3 audio encoding when making a compressed file (default)"
181     echo >&2 "   -r <x.x>      Apply extra dynamic range compression to the audio, making soft sounds louder. "
182     echo >&2 "                 Range is 1.0 to 4.0 with 1.5 - 2.5 being a useful range (HandBrake Only) (default value is 0.0)"
183     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
184     echo >&2 "                 In -z mode, run with this option to keep the original .VOB file"
185     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
186     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
187     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
188     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
189     echo >&2 ""
190     exit 2
191 }
192
193 if (($errors)) || (($show_usage))
194 then
195   usage
196 fi
197
198 # Sanity Check - Command Line Options 
199 if [ "$dest" == "" ]; then
200   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
201   usage
202 fi
203
204 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
205    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
206     # Make our default dest type a compressed movie if the user didn't ask for anything else to be done
207     make_final_dest_comp=1
208 fi
209
210 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
211   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-z' when using '-b' or '-s' or '-a'" | tee -a $logfile
212   usage
213 fi
214
215 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
216   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
217   usage
218 fi
219
220 if [ $mirror_mode -eq 1 ]; then
221   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
222      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
223     echo "-E- You can't specify '-v' or '-i' or '-f' or '-z' when operating in mirror mode with '-m'" | tee -a $logfile
224     usage
225   fi
226 fi
227
228 # Make handbrake the default encoder if not specified and we can find it
229 if [ -z "$encoder" ]; then
230   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
231   [[ -x `which $handbrake_xvid` ]] && [[ "$profile" =~ "xvid" ]] && encoder="handbrake";
232   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "mp4" ]] && encoder="handbrake";
233   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "ip" ]] && encoder="handbrake";
234   [[ -x `which $handbrake_mp4` ]] && [[ "$profile" =~ "hb" ]] && encoder="handbrake";
235 fi
236
237 # Sanity check the profile selection
238 if [[ "$encoder" == "mencoder" ]]; then
239   [[ "$profile" =~ "mp4" ]] && echo "-E- invalid encoder $encoder selected for mp4 profile: $profile" && exit
240 fi
241
242 if [[ "$encoder" != "mencoder" ]] && [[ "$encoder" != "handbrake" ]]; then
243   echo "-E- Invalid encoder specified: $encoder"
244   exit 1
245 fi
246
247 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
248 if [ "$aspect" != "" ]; then
249   echo "$aspect" | grep -q "x"
250   if [ $? == 0 ]; then
251     echo "-E- You must specify the aspect option with a value whose format is W:H"
252     exit 1
253   fi
254   echo "$aspect" | grep -q ":"
255   if [ $? != 0 ]; then
256     [ "$encoder" == "mencoder" ] && SCALE=",scale -zoom -sws 9 -xy $aspect"
257     [ "$encoder" == "handbrake" ] && SCALE="-w $aspect"
258   else
259     [ "$encoder" == "mencoder" ] && SCALE=",scale=$aspect"
260     if [ "$encoder" == "handbrake" ]; then
261        WIDTH=`echo "$aspect" | awk -F ':' '{ print $1; }'`
262        HEIGHT=`echo "$aspect" | awk -F ':' '{ print $2; }'`
263        SCALE="-w $WIDTH -l $HEIGHT"
264     fi
265   fi
266 fi
267
268 # Sanity Check - Key executables
269 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
270 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
271 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
272 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
273 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
274 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
275 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
276 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
277 [[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
278 [[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
279 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
280 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
281 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
282 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "hb" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
283 [[ "$encoder" == "handbrake" ]] && [[ ! -x `which ffmpeg` ]] && echo "-E- missing dependency: ffmpeg" && exit
284
285 ##############################################################################################
286
287 typeset -i ripdvd
288 if [ -z "$dvdname" ]; then
289
290   # make sure the DVD device is accessible
291   volname $dev > /dev/null 2>&1
292   if [ $? != 0 ]; then
293     echo "-E- Can't access the DVD device $dev"
294     exit 1
295   fi
296   # now capture the volume name from the device
297   dvdname=`volname $dev | awk '{ print $1 }'`
298   ripdvd=1
299
300 else 
301
302   # check to see if dvdname is a full path to a real directory
303   # if it is, set dvdname and dvdpath appropriately
304   if [ -d "$dvdname" ]; then
305     dvdpath="$dvdname"
306     dvdname=`basename "$dvdname"`
307     keep_dvdfolder=1
308     if [ -z "$dvdname" ]; then
309      echo "-E- Unable to extract dvdname from path: $dvdpath"
310      exit 1
311     fi
312     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
313       echo "-E- You must supply a full path to a valid DVD folder with this option"
314       exit 1
315     fi
316   fi
317
318   # Check to see if dvdname is a full path to a file
319   if [ -f "$dvdname" ]; then
320     valid_file=0
321
322     # check to see if dvdname is a full path to an MPG2 (VOB) file
323     # if it is, set dvdname and vobfile appropriately
324     file "$dvdname" | grep -q "MPEG"
325     if [ $? == 0 ]; then
326       # It is a valid MPEG2 file, now strip the extension off our dvdname
327       vobfile="$dvdname"
328       dvdname=`basename "$dvdname"`
329       dvdname=${dvdname%.[^.]*}
330       keep_vobfile=1
331       valid_file=1
332     fi
333
334     # check to see if dvdname is a full path to an ISO file
335     # if it is, set dvdname and isofile appropriately
336     file "$dvdname" | grep -q -e "ISO" -e "UDF"
337     if [ $? == 0 ]; then
338       # It is a valid ISO file, now strip the extension off our dvdname
339       isofile="$dvdname"
340       dvdname=`basename "$dvdname"`
341       dvdname=${dvdname%.[^.]*}
342       keep_isofile=1
343       valid_file=1
344     fi    
345
346     # check to see if dvdname is a full path to an ISO file
347     # if it is, set dvdname and isofile appropriately
348     file "$dvdname" | grep -q -e "VOB"
349     if [ $? == 0 ]; then
350       # It is a valid VOB file, now strip the extension off our dvdname
351       vobfile="$dvdname"
352       dvdname=`basename "$dvdname"`
353       dvdname=${dvdname%.[^.]*}
354       keep_vobfile=1
355       valid_file=1
356     fi    
357
358     # If we didn't find a handler for the file above, complain
359     if [ $valid_file -eq 0 ]; then
360       echo "-E- Unsupported file type: $vobfile"
361       exit 1
362     fi
363
364   # Throw an error if we can't find what the -n option is pointing to
365   else 
366     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
367     exit 1
368   fi
369
370   # Set the ripdvd flag to false since we aren't ripping a DVD disk
371   ripdvd=0
372
373   # Since we aren't ripping a DVD disk, don't eject anything either
374   eject_disk=0
375
376 fi
377
378 # remove bad characters from the dvdname
379 dvdname=${dvdname%.} # remove trailing '.' character
380
381 # add the suffix extension to the end of the dvdname
382 dvdname=$dvdname$extension
383
384 # make a "safe" dvdname (remove special characters)
385 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
386
387 # Make sure we have a non-empty dvdname
388 if [ -z "$dvdname" ]; then
389   echo "-E- unable to determine dvdname"
390   exit 1
391 fi
392
393 # make sure our vobfile value is set
394 if [ -z "$vobfile" ]; then
395   vobfile="$dest/$dvdname.VOB"
396 fi
397
398 # set up some variables to hold various logfiles
399 logfile="$logdir/$dvdname.log"
400 passlogfile="$tmpdir/$safedvdname.log"
401 ddrescuelog=`tempfile`
402 dvdauthorlog=`tempfile`
403 encodelog=`tempfile`
404 dumplog=`tempfile`
405
406 # create the tmpdir if it doesn't already exist
407 if [ ! -d "$tmpdir" ]; then
408   mkdir -p "$tmpdir"
409   if [ $? != 0 ]; then
410     echo "-E- Unable to create the tmpdir: $tmpdir"
411     exit 1
412   fi
413 fi
414
415 # create the logdir if it doesn't already exist
416 if [ ! -d "$logdir" ]; then
417   mkdir -p "$logdir"
418   if [ $? != 0 ]; then
419     echo "-E- Unable to create the logdir: $logdir"
420     exit 1
421   fi
422 fi
423
424 ##############################################################################################
425 # cleanup functions
426 ##############################################################################################
427 cleanup() { 
428   if [ $keep_intermediate_files -eq 0 ]; then
429     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
430     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
431     [[ -e "$encodelog" ]] && rm -f "$encodelog"
432     [[ -e "$dumplog" ]] && rm -f "$dumplog"
433   else
434     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
435     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
436     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
437     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
438   fi
439   echo ""
440 }
441
442 fatal_and_exit() {
443   if [[ -z "$1" ]]; then
444     msg="-E- control-c killed us"
445   else
446     msg=$1
447   fi
448   echo -e 2>&1 "$msg" | tee -a "$logfile"
449   if [[ -n "$mailto" ]]; then
450     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
451   fi
452   keep_intermediate_files=1
453   exit 1
454 }
455
456 # Call our cleanup functions on INT and EXIT signals
457 trap fatal_and_exit INT
458 trap cleanup EXIT
459
460 ##############################################################################################
461 # processing functions
462 ##############################################################################################
463
464 # encode the vob file into a compressed file format using handbrake
465 function encode_vob_file_handbrake {
466   
467   # declare some globals
468   typeset handbrake_cli=""
469   typeset handbrake_video_encoder_opts=""
470   typeset filetype=""
471   typeset handbrake_audio_opts=""
472   typeset hb_profile=""
473   typeset SIZE=""
474
475   # Set a variable that we will use later to determine if we found a handler for $profile or not
476   typeset -i found_profile=0    
477
478   # For a given profile, to override the 2 pass behavior to be single pass,
479   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
480   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
481   PASSES="-2"
482
483   # Set our DRC option
484   DRC="-D $drc"
485
486   if [ $target_size -ne 0 ]; then
487     SIZE="-S $target_size"
488   fi 
489
490   # Check the global force_onepass_mode. If it is set, change our variables appropriately
491   # to force 1-pass encoding across all profiles.
492   if [ $force_onepass_mode -eq 1 ]; then
493     PASSES=""
494   fi
495
496   # get our audio track from the VOB file (requires mp4 version of handbrake to extract)
497   get_audio_track_from_vob "$vobfile" "$handbrake_mp4"
498
499   # XVID profile
500   if [[ "$profile" =~ "xvid" ]]; then
501     found_profile=1
502     handbrake_cli="$handbrake_xvid"
503     final_output_file="$dest/$dvdname.avi"
504     filetype="avi"
505
506     # Very High Quality (16fps)
507     if [ "$profile" == "xvidvhq" ]; then
508       handbrake_opts[0]="-f avi"
509       handbrake_opts[1]="-b $target_bitrate"
510       handbrake_opts[2]="-e xvid"
511       handbrake_opts[3]="-T"
512       handbrake_opts[4]="-5"
513       handbrake_opts[5]="-8"
514     fi
515     # High Quality (20fps)
516     if [ "$profile" == "xvidhq" ]; then
517       handbrake_opts[0]="-f avi"
518       handbrake_opts[1]="-b $target_bitrate"
519       handbrake_opts[2]="-e ffmpeg"
520       handbrake_opts[3]="-T"
521       handbrake_opts[4]="-5"
522     fi
523     # Fast (28fps)
524     if [ "$profile" == "xvid" ]; then
525       handbrake_opts[0]="-f avi"
526       handbrake_opts[1]="-b $target_bitrate"
527       handbrake_opts[2]="-e ffmpeg"
528       handbrake_opts[3]="-T"
529     fi
530   fi
531
532   # MP4 profile
533   if [[ "$profile" =~ "mp4" ]]; then
534     found_profile=1
535     handbrake_cli="$handbrake_mp4"
536     final_output_file="$dest/$dvdname.mp4"
537     PASSES=""
538
539     # Handle custom parameter overrides
540     if [ $custom_bitrate == 1 ]; then
541       handbrake_opts[0]="-b $target_bitrate"
542     fi
543     if [ $custom_audio_2ch == 0 ]; then
544       audio_2ch=0
545     fi
546     if [ $custom_audio_6ch == 0 ]; then
547       audio_6ch=0
548     fi
549
550     # Very High Quality
551     if [ "$profile" == "mp4vhq" ]; then
552       profile="hb_High_Profile"
553     fi
554     # High Quality
555     if [ "$profile" == "mp4hq" ]; then
556       profile="hb_Normal"
557     fi
558     # Fast
559     if [ "$profile" == "mp4" ]; then
560       profile="hb_Classic"
561     fi
562   fi
563
564   # iphone and ipod MP4 profiles
565   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
566     found_profile=1
567     handbrake_cli="$handbrake_mp4"
568     final_output_file="$dest/$dvdname.mp4"
569     PASSES=""
570
571     # Handle custom parameter overrides
572     if [ $custom_bitrate == 1 ]; then
573       handbrake_opts[0]="-b $target_bitrate"
574     fi
575     if [ $custom_audio_2ch == 0 ]; then
576       audio_2ch=0
577     fi
578     if [ $custom_audio_6ch == 0 ]; then
579       audio_6ch=0
580     fi
581
582     # iphone
583     if [ "$profile" == "iphone" ]; then
584       profile="hb_iPhone_&_iPod_Touch"
585     fi
586     # ipod
587     if [ "$profile" == "ipod" ]; then
588       profile="hb_iPod"
589     fi
590
591   fi
592   
593   # Predefined Handbrake Profile Handling
594   if [[ "$profile" =~ "hb" ]]; then
595     found_profile=1
596     handbrake_cli="$handbrake_mp4"
597     final_output_file="$dest/$dvdname.mp4"
598     PASSES=""
599
600     # Handle custom parameter overrides
601     if [ $custom_bitrate == 1 ]; then
602       handbrake_opts[0]="-b $target_bitrate"
603     fi
604     if [ $custom_audio_2ch == 0 ]; then
605       audio_2ch=0
606     fi
607     if [ $custom_audio_6ch == 0 ]; then
608       audio_6ch=0
609     fi
610     
611     # extract the HandBrake Profile name from $profile
612     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
613   fi
614
615   # Make sure we found a handler for the given profile
616   if [ $found_profile -eq 0 ]; then
617     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
618   fi
619
620   # setup our audio option
621   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 1 ]; then
622     handbrake_audio_opts="-E faac,ac3 -6 dpl2,auto"
623   fi
624   if [ $audio_6ch -eq 1 ] && [ $audio_2ch -eq 0 ]; then
625     handbrake_audio_opts="-E ac3 -6 auto"
626   fi
627   if [ $audio_2ch -eq 1 ] && [ $audio_6ch -eq 0 ]; then
628     handbrake_audio_opts="-E faac -6 dpl2"
629   fi
630   if [ -n "$track" ]; then
631     handbrake_audio_opts="$handbrake_audio_opts -a $track"
632   fi
633
634   # Convert our array of opts into a string
635   for OPTS in "${video_encoder_opts[@]}"; do 
636     handbrake_video_encoder_opts="$handbrake_video_encoder_opts:$OPTS"
637   done
638   if [ -n "$handbrake_video_encoder_opts" ]; then
639     handbrake_video_encoder_opts="-x $handbrake_video_encoder_opts"
640   fi
641   for OPTS in "${handbrake_opts[@]}"; do 
642     handbrake_cmd_line_opts="$handbrake_cmd_line_opts $OPTS"
643   done
644
645   # Append "global" command line options
646   handbrake_cmd_line_opts="$handbrake_cmd_line_opts -v 1"
647   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
648   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
649   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
650   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
651
652   # Execute the handbrake command to encode the video
653   # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
654   # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
655   if [ -n "$hb_profile" ]; then
656     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
657     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
658     handbrake_retval=$?
659   else 
660     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
661     $handbrake_cli -i "$vobfile" -o "$final_output_file" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
662     handbrake_retval=$?
663   fi
664   if [ $handbrake_retval != 0 ]; then
665     fatal_and_exit "-E- Unhandled handbrake error"
666   fi
667
668   # Concatenate the encode log to our main log file, greping out unwanted lines
669   cat $encodelog | grep -v "Encoding:" | grep -v "hb_demux_ps" >> "$logfile" 
670   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | head -1 >> "$logfile"
671   cat $encodelog | grep "Encoding:" | sed 's/\r/\n/g' | grep "Encoding:" | grep "ETA" | tail -1 >> "$logfile"
672 }
673
674 # encode the vob file into a compressed file format using mencoder
675 function encode_vob_file_mencoder {
676
677   # Set a variable that we will use later to determine if we found a handler for $profile or not
678   typeset -i found_profile=0
679
680   # For a given profile, to override the 2 pass behavior to be single pass,
681   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
682   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
683   PASSES="1 2"
684
685   # Declare our default 2 pass variables
686   passlogfile_opt="-passlogfile $passlogfile"
687   pass_opt="pass=%PASS"
688
689   # Check the global force_onepass_mode. If it is set, change our variables appropriately
690   # to force 1-pass encoding across all profiles.
691   if [ $force_onepass_mode -eq 1 ]; then
692     PASSES="2"
693     passlogfile_opt=""
694     pass_opt=""    
695   fi
696
697   # XVID profile
698   if [[ "$profile" =~ "xvid" ]]; then
699     found_profile=1
700     final_output_file="$dest/$dvdname.avi"
701     mencoder_general_opts="$lang_opts $passlogfile_opt"
702     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
703     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
704     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
705
706     # Very High Quality (16fps)
707     if [ "$profile" == "xvidvhq" ]; then
708       video_encoder_opts[0]="bitrate=$target_bitrate"
709       video_encoder_opts[1]="threads=$mencoder_threads"
710       video_encoder_opts[2]="chroma_opt"
711       video_encoder_opts[3]="vhq=4"
712       video_encoder_opts[4]="bvhq=1"
713       video_encoder_opts[5]="quant_type=mpeg"
714       video_encoder_opts[6]="autoaspect"
715     fi
716     # High Quality (20fps)
717     if [ "$profile" == "xvidhq" ]; then
718       video_encoder_opts[0]="bitrate=$target_bitrate"
719       video_encoder_opts[1]="threads=$mencoder_threads"
720       video_encoder_opts[2]="chroma_opt"
721       video_encoder_opts[3]="vhq=2"
722       video_encoder_opts[4]="bvhq=1"
723       video_encoder_opts[5]="quant_type=mpeg"
724       video_encoder_opts[6]="autoaspect"
725     fi
726     # Fast (28fps)
727     if [ "$profile" == "xvid" ]; then
728       video_encoder_opts[0]="bitrate=$target_bitrate"
729       video_encoder_opts[1]="threads=$mencoder_threads"
730       video_encoder_opts[2]="vhq=0"
731       video_encoder_opts[3]="turbo"
732       video_encoder_opts[4]="autoaspect"
733     fi
734
735     for OPTS in "${video_encoder_opts[@]}"; do 
736       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
737     done
738
739     if [ $audio_2ch -eq 0 ]; then
740       # These options produce good 6 channel audio for linux and windows
741       mencoder_audio_opts="-oac copy"
742       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
743       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
744       mencoder_audioch_opts[1]="-af channels=6"
745       mencoder_audioch_opts[2]=""
746     else
747       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
748       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
749       mencoder_audioch_opts[0]=""
750     fi
751  
752   fi
753
754   # iphone and ipod MP4 profiles
755   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
756     found_profile=1
757     if [ "$profile" == "iphone" ]; then
758       # SCALE: 480x320
759       # scale width to 480, set height appropriately, but keep a multiple of 16
760       #SCALE=",scale=480:-10"
761       # scale the video down however far is necessary to fit in 480x320
762       SCALE=",dsize=480:320:0,scale=-8:-8"
763     else
764       # SCALE: 320x240
765       # scale width to 320, set height appropriately, but keep a multiple of 16
766       #SCALE=",scale=320:-10"
767       # scale the video down however far is necessary to fit in 320x240
768       SCALE=",dsize=320:240:0,scale=-8:-8"
769     fi
770     final_output_file="$dest/$dvdname.mp4"
771     mencoder_general_opts="$lang_opts $passlogfile_opt"
772     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
773     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
774     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
775     video_encoder_opts[0]="bitrate=$target_bitrate"
776     video_encoder_opts[1]="threads=$mencoder_threads"
777     video_encoder_opts[2]="vbv_maxrate=1500"
778     video_encoder_opts[3]="vbv_bufsize=2000"
779     video_encoder_opts[4]="nocabac"
780     video_encoder_opts[5]="me=umh"
781     video_encoder_opts[6]="subq=6"
782     video_encoder_opts[7]="frameref=6"
783     video_encoder_opts[8]="trellis=1"
784     video_encoder_opts[9]="level_idc=30"
785     video_encoder_opts[10]="global_header"
786     video_encoder_opts[11]="bframes=0"
787     video_encoder_opts[12]="partitions=all"
788     for OPTS in "${video_encoder_opts[@]}"; do 
789       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
790     done
791
792     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
793     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
794   fi
795
796   if [ $found_profile -eq 0 ]; then
797     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
798   fi
799
800   # Do not edit this line. $mencoder_video_encoder_opts must be last
801   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
802   mencoder_retval=0
803
804   for PASS in $PASSES
805   do 
806     # Set some options based on which pass we are in
807     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
808     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
809     [ $PASS -eq 1 ] && output_file="/dev/null"
810     [ $PASS -eq 2 ] && output_file="$final_output_file"
811   
812     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
813     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
814     do
815       echo -e "   Encoding pass $PASS"
816       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
817       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
818       mencoder_retval=$? 
819       grep -q "\[channels\] Invalid" $encodelog
820       if [ $? != 0 ]; then          
821         break;
822       else
823         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
824       fi
825     done
826       
827     if [ $mencoder_retval != 0 ]; then
828       fatal_and_exit "-E- Unhandled mencoder error"
829     fi
830
831     # Concatenate the encode log to our main log file, greping out unwanted lines
832     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
833
834   done
835 }
836
837 function make_dvd_iso_image {
838
839   isofile="$1"
840
841   # check to see if we have a dvdpath to rip from instead of $dev
842   if [ -z "$dvdpath" ]; then
843     # load the CSS codes in the DVD drive 
844     lsdvd $dev >> "$logfile"
845     if [ $? != 0 ]; then
846       fatal_and_exit "-E- lsdvd $dev failed" 
847     fi
848
849     # read the DVD, ignoring/skipping CRC errors
850     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
851     if [ $? != 0 ]; then
852       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
853     fi
854     cat "$ddrescuelog" >> "$logfile"
855   else
856     # rip from a path instead
857     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
858   fi
859 }
860
861 function make_dvd_iso_image_from_folder {
862   
863   src="$1"
864   dst="$2"
865   handle_error=$3
866   
867   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
868
869   # make an iso image out of our directory
870   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
871   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
872
873   # set the audio languages from the iso if it exists and is non-zero in size
874   if [ -s "$dst" ]; then
875     get_feature_title "$dst"
876     get_audio_id_from_iso "$dst"
877   fi
878
879   # make sure we were able to create the iso image from the folder given to us
880   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
881     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
882     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
883     # remove the bad iso file
884     [[ -e "$dst" ]] && rm -f "$dst"
885     # get the feature title from the DVD folder
886     get_feature_title "$dvdpath"
887     # create our main VOB file from the ISO
888     create_main_vob_with_mplayer "$dvdpath" 
889     # get our audio id from the VOB file
890     get_audio_id_from_vob "$vobfile"
891   fi
892 }
893
894 function make_dvdbackup_folder_image {
895   # extract the feature title from the DVD image
896   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
897   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
898   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
899   if [ $? != 0 ]; then
900     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
901   fi
902 }
903
904 function make_dvdauthor_folder_image {
905   # create a new DVD video of the feature title
906   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
907   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
908   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
909   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
910
911   # There is a chance that dvdauthor won't like some of the VOBs.
912   # We can't tell ahead of time which ones it will choke on. 
913   # So, we need to run it over and over again until it can process
914   # all the VOBs. If it can't handle one of them, run it through
915   # mencoder to fix it and try again. These errors are typically
916   # present due to the copy protection that ddrescue removed.
917   grep -q "SCR moves" $dvdauthorlog
918   while [ $? == 0 ]; do
919     # fix bad vobs that get the "SCR moves backwards" error:
920     #  STAT: Processing VTS_01_0.VOB...
921     #  ERR:  SCR moves backwards, remultiplex input.
922     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
923     if [[ ! -f "$badvob" ]]; then
924       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
925     fi
926     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
927     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
928     mv -f $badvob.fixed $badvob
929     echo "-> Creating DVD video $dest/$dvdname"
930     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
931     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
932     grep -q "SCR moves" $dvdauthorlog
933   done
934 }
935
936 function get_feature_title {
937   source="$1"
938   # if a feature title was given on the command line, use it
939   if [ $feature_title_override -ne 0 ]; then
940     feature_title=$feature_title_override
941     return 0
942   fi
943   # otherwise, use lsdvd to figure it out
944   if [ $ripdvd -eq 1 ]; then
945     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
946   else 
947     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
948   fi
949 }
950
951 function create_main_vob_with_cat {
952   # cd to the feature title DVD folder
953   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
954   if [ $? != 0 ]; then
955     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
956   fi
957
958   # concatenate all the VOBs together into 1 giant VOB
959   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
960   cat $vobs > "$tmpdir/$dvdname.VOB"
961
962   # cd back to the dir we started from
963   popd > /dev/null 2>&1
964 }
965
966 function create_main_vob_with_mplayer {
967
968   # argument processing  
969   source="$1"
970   remove_dumplog=$2
971
972   # make sure we have a valid feature title
973   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
974     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
975   fi
976
977   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
978   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
979     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
980     msg="$msg We also detected another condition that requires us to use dumpstream. "
981     msg="$msg\n    Unable to rip this DVD in the mode you requested."
982     fatal_and_exit "$msg"
983   fi
984
985   # use mplayer to create the main VOB file
986   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
987   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
988   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
989   if [ $? != 0 ]; then
990     cat $dumplog | grep -v "^A:" >> "$logfile"
991     fatal_and_exit "-E- Mplayer Failed"
992   fi
993   cat $dumplog | grep -v "^A:" >> "$logfile"
994   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
995 }
996
997 function get_audio_id_from_iso {
998   # Adjust our audio ID to find the english audio stream
999   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1000   iso="$1"
1001   aidcheck=`tempfile`
1002   aid=$default_aid
1003   alang=$default_alang
1004   if [ $aid_override -lt 0 ]; then 
1005     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
1006     grep -q "aid: $aid" $aidcheck
1007     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1008       (( aid = aid + 1 ))
1009       grep -q "aid: $aid" $aidcheck
1010     done
1011     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1012   else
1013     aid=$aid_override
1014   fi
1015   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1016   # mencoder default DVD audio track language selection (english)
1017   lang_opts="-aid $aid -alang $alang"
1018 }
1019
1020 function get_crop_from_iso { 
1021   FRAMES=10000
1022   echo "-> Detecting black frame border crop value from ISO file"
1023   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
1024   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
1025   [[ -e "md5sums" ]] && rm -f "md5sums"
1026   CROP=`cat $dumplog | grep CROP | tail -1`
1027   echo "   Found crop value of $CROP" >> "$logfile"
1028   CROP=${CROP#* crop=}
1029   CROP=${CROP%%\).*}
1030   typeset -i CROPCHECK
1031   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1032   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1033   if [ -z "$CROP" ]; then
1034     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1035     return
1036   fi
1037   if [ $CROPCHECK -lt 0 ]; then 
1038     CROP=""
1039   else 
1040     CROP=",crop=$CROP"
1041   fi
1042   echo "   Setting mencoder crop filter to: $CROP"
1043 }
1044
1045 function get_crop_from_vob { 
1046   FRAMES=10000
1047   echo "-> Detecting black frame border crop value from VOB file"
1048   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
1049   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
1050   [[ -e "md5sums" ]] && rm -f "md5sums"
1051   CROP=`cat $dumplog | grep CROP | tail -1`
1052   echo "   Found crop value of $CROP" >> "$logfile"
1053   CROP=${CROP#* crop=}
1054   CROP=${CROP%%\).*}
1055   typeset -i CROPCHECK
1056   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
1057   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
1058   if [ -z "$CROP" ]; then
1059     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
1060     return
1061   fi
1062   if [ $CROPCHECK -lt 0 ]; then 
1063     CROP=""
1064   else 
1065     CROP=",crop=$CROP"
1066   fi
1067   echo "   Setting mencoder crop filter to: $CROP"
1068 }
1069
1070 function get_audio_track_from_vob {
1071   # Adjust our audio ID to find the english audio stream
1072   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1073   vob="$1"
1074   handbrake_cli="$2"
1075   aidcheck=`tempfile`
1076   aid=$default_aid
1077   alang=$default_alang
1078   if [ $aid_override -lt 0 ]; then 
1079     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1080     grep -q "Found audio stream: $aid" $aidcheck
1081     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1082       (( aid = aid + 1 ))
1083       grep -q "Found audio stream: $aid" $aidcheck
1084     done
1085     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1086   else 
1087     aid=$aid_override
1088   fi
1089   # Now that we've found the right audio id, find the corresponding audio track in HandBrake
1090
1091   # convert the aid we found into hex
1092   aid_hex=`echo "obase=16; $aid" | bc`
1093   
1094   # extract the audio streams in the vob
1095   #ffmpeg -i "$vob" > $aidcheck 2>&1
1096   $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
1097   
1098   # find the stream that matches our aid
1099   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
1100   #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
1101   stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
1102  
1103   # extract the track number that handbrake uses
1104   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
1105   track=`expr match "$stream" '^\([0-9]*\):'`
1106
1107   if [ -n "$track" ]; then   
1108     echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
1109   fi
1110 }
1111
1112 function get_audio_id_from_vob {
1113   # Adjust our audio ID to find the english audio stream
1114   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
1115   vob="$1"
1116   aidcheck=`tempfile`
1117   aid=$default_aid
1118   alang=$default_alang
1119   if [ $aid_override -lt 0 ]; then 
1120     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
1121     grep -q "Found audio stream: $aid" $aidcheck
1122     while [ $? == 1 ] && [ $aid -lt 159 ]; do
1123       (( aid = aid + 1 ))
1124       grep -q "Found audio stream: $aid" $aidcheck
1125     done
1126     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
1127   else 
1128     aid=$aid_override
1129   fi
1130   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
1131   # mencoder default DVD audio track language selection (english)
1132   lang_opts="-aid $aid -alang $alang"
1133 }
1134
1135 function check_vob_for_corrupted_start {
1136   # check to see if the beginning of the DVD has a form of copy protection
1137   # where they have deliberately broken the first X number of frames of the DVD.
1138   # If we don't skip these, our resulting VOB file will not play.
1139   badvobcheck=`tempfile`
1140   endpos=360
1141   skip=0
1142   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1143   if [ $? != 0 ]; then
1144     fatal_and_exit "-E- Mencoder Failed"
1145   fi
1146   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1147   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
1148     (( skip = skip + 5 ))
1149     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
1150     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
1151     if [ $? != 0 ]; then
1152       fatal_and_exit "-E- Mencoder Failed"
1153     fi
1154     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
1155   done
1156   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
1157
1158   # cat the giant VOB into mencoder to create a playable VOB file
1159   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
1160   if [ $? != 0 ]; then
1161     fatal_and_exit "-E- Mencoder Failed"
1162   fi
1163 }
1164
1165 function check_vob_for_completeness {
1166   # check to make sure we got out a complete VOB.
1167   # there is another kind of copy protection where the VOB's may
1168   # have "MPG EOF" frames in the middle of the stream. 
1169   # this causes mencoder to not process the entire VOB, and exit without any errors.
1170   # detect this by seeing how much smaller the dst vob is from the src vob.
1171   MAX_FILESIZE_DELTA_PERCENT=70
1172   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
1173   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1174   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1175   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1176     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1177     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
1178     create_main_vob_with_mplayer "$isofile"
1179     [[ -e "$dumplog" ]] && rm -f $dumplog
1180     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
1181     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
1182     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
1183       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
1184     fi
1185   fi
1186 }
1187
1188 function check_vob_for_too_many_video_packets {
1189   # If our earlier algorithm to work around this failed, throw an error.
1190   # check to see if this DVD has a protection scheme we don't know how to work around
1191   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
1192   # for some reason, the video is black, while the audio rolls, then the video finally comes
1193   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
1194   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
1195   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
1196   grep -q "Too many video packets in the buffer:" "$logfile"
1197   if [ $? == 0 ]; then
1198     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
1199     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
1200     create_main_vob_with_mplayer "$isofile"
1201     grep -q "Too many video packets in the buffer:" $dumplog
1202     if [ $? == 0 ]; then
1203       [[ -e "$dumplog" ]] && rm -f $dumplog
1204       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1205     fi
1206     [[ -e "$dumplog" ]] && rm -f $dumplog
1207   fi
1208 }
1209
1210 function check_vob_for_a52_crc_errors {
1211   # Let's see if we can playback our newly created VOB file without any errors.
1212   # if there are issues, let's detect them now, and try to recreate the VOB
1213   # there are some forms of copy protection that have missed above, that evidence
1214   # themselves when we try to playback the VOB file. This was added to deal with
1215   # the "a52: CRC check failed" copy protection scheme.
1216   MAX_ERRORS=10
1217   ENDPOS=120
1218   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1219   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1220   cat $dumplog | grep -v "^A:" >> "$logfile"
1221   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1222   if [ $errors -gt $MAX_ERRORS ]; then
1223     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
1224     create_main_vob_with_mplayer "$isofile"
1225     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
1226     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
1227     if [ $? != 0 ]; then
1228       cat $dumplog | grep -v "^A:" >> "$logfile"
1229       fatal_and_exit "-E- Mplayer Failed"
1230     fi
1231     cat $dumplog | grep -v "^A:" >> "$logfile"
1232     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
1233     if [ $errors -gt $MAX_ERRORS ]; then
1234       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
1235     fi
1236   fi
1237   [[ -e "$dumplog" ]] && rm -f $dumplog
1238 }
1239
1240 function calculate_bitrate_from_target_size {
1241   # determine what our bitrate needs to be if a target size was specified instead
1242   if [ $target_size -ne 0 ]; then
1243     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1244     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1245     custom_bitrate=1
1246     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1247   fi
1248 }
1249
1250 function create_dvdauthor_dvd_xml_file {
1251   # make a dvdauthor xml menu file to create a valid DVD video from 
1252   # this script does a good job, but we'll still need to clean it up a bit after it runs
1253   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1254   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1255   if [ $? != 0 ]; then
1256     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1257   fi
1258
1259   # replace the first line of the xml file to remove the bad dest path
1260   awk -v line=1 -v new_content="<dvdauthor>" '{
1261     if (NR == line) {
1262       print new_content;
1263     } else {
1264       print $0;
1265     }
1266   }' dvd.xml > dvd.xml.new
1267   mv -f dvd.xml.new dvd.xml
1268   if [ $? != 0 ]; then
1269     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1270   fi
1271
1272   # remove the "<video " property line from the xml file
1273   cat dvd.xml | grep -v "<video" > dvd.xml.new
1274   mv -f dvd.xml.new dvd.xml
1275   if [ $? != 0 ]; then
1276     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1277   fi
1278   
1279   # remove the extra <pgc>..</pgc> pairs
1280   cat dvd.xml | awk 'BEGIN {x=1}
1281   {
1282     if ($0~"</pgc>") {x=0}
1283     if (x==1) {print $0}
1284     if ($0~"<pgc>") {x=1}
1285   }' > dvd.xml.new
1286   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1287   mv -f dvd.xml.new dvd.xml
1288   if [ $? != 0 ]; then
1289     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1290   fi
1291
1292   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1293   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1294   mv -f dvd.xml.new dvd.xml
1295   if [ $? != 0 ]; then
1296     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1297   fi
1298 }
1299
1300 function check_for_mplayer_dumpstream_incompatibility {
1301
1302   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1303
1304   if [ ! -e "$vobfile" ]; then
1305     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1306     # A DVD that has 99 titles, where the longest title isn't the main feature
1307     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1308     # out what the feature title is. This script will run through that flow if we
1309     # set use_mplayer_dumpstream to 0. Check for this here.
1310     if [ $ripdvd -eq 1 ]; then
1311       lsdvd $dev | grep -q "Title: 99"
1312     else
1313       lsdvd "$isofile" | grep -q "Title: 99"
1314     fi
1315     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1316     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1317       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1318         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1319         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1320         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1321         invalid_feature_title=1
1322       else 
1323         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1324         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1325         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1326         use_mplayer_dumpstream=0
1327         invalid_feature_title=1
1328       fi
1329       return
1330     fi
1331   fi
1332
1333   # There is another form of protection that causes the mplayer dumpstream to fail. 
1334   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1335   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1336   # problem before continuing.
1337   if [ -e "$vobfile" ]; then
1338     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1339     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1340     grep -q "Too many audio packets in the buffer" $dumplog
1341     if [ $? == 0 ]; then
1342       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1343       use_mplayer_dumpstream=0
1344       mplayer_dumpstream_incompatibility=1
1345     fi
1346     [[ -e "$dumplog" ]] && rm -f $dumplog
1347   fi
1348 }
1349
1350 function fill_mythvideo_metadata {
1351
1352   # This function must be passed the filename as an argument
1353   # The filename must be a full path to the file
1354   filename="$1"
1355
1356   # Make sure the fill mythvideo metadata option has been set to 1
1357   if [ $fill_mythvideo_metadata -eq 0 ]; then
1358     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1359     return 0
1360   fi
1361
1362   # If the fill mythvideo metadata script is present, run it
1363   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1364   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1365     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1366     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1367   else
1368     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1369     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1370   fi
1371 }
1372
1373 # remove the intermediate VOB file
1374 function remove_intermediate_vob_file {
1375   if [ $keep_intermediate_files -eq 0 ]; then
1376     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1377   else
1378     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1379   fi
1380 }
1381
1382 # remove the original DVD image 
1383 function remove_intermediate_iso_file {
1384   [[ $keep_isofile -eq 1 ]] && return 1
1385   if [ $keep_intermediate_files -eq 0 ]; then
1386     [[ -e "$isofile" ]] && rm "$isofile"
1387   else
1388     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1389   fi
1390 }
1391
1392 # remove the intermediate dvdbackup folder
1393 function remove_intermediate_dvdbackup_folder {
1394   if [ $keep_intermediate_files -eq 0 ]; then
1395     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1396   else
1397     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1398   fi
1399 }
1400
1401 ##############################################################################################
1402 # MAIN
1403 ##############################################################################################
1404
1405 # Make a note of when this DVD rip started
1406 date=`date`
1407 echo -e "\n$date DVD rip started" >> "$logfile"
1408 echo "$cmd" >> "$logfile"
1409
1410 # Rip the DVD - Mirror Mode
1411 if [ $mirror_mode -eq 1 ]; then
1412   echo "-> Ripping DVD $dvdname to $dest"
1413
1414   # use ddrescue to make an ISO image of the disk
1415   make_dvd_iso_image "$dest/$dvdname.iso"
1416
1417   # add this video data to the mythtv DB
1418   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1419
1420   # eject the disk upon completion
1421   if [ $eject_disk -ne 0 ]; then
1422     eject -T $dev
1423   fi
1424
1425   date=`date`
1426   echo "$date DVD rip completed" | tee -a "$logfile"
1427
1428   if [[ -n "$mailto" ]]; then
1429     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1430   fi
1431
1432 fi
1433
1434 # Rip the DVD - Main Title Feature Only
1435 if [ $mirror_mode -eq 0 ]; then
1436
1437   # Rip image from DVD
1438   if [ $ripdvd -eq 1 ]; then
1439     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1440     # use ddrescue to make an ISO image of the disk
1441     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1442   fi
1443
1444   # Rip image from DVD path
1445   if [ -n "$dvdpath" ]; then
1446     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1447     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1448   fi
1449
1450   # make sure our isofile value is set
1451   if [ -z "$isofile" ]; then
1452     isofile="$tmpdir/$dvdname.iso"
1453   fi
1454      
1455   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1456
1457     if [ ! -e "$vobfile" ]; then
1458       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1459       
1460       # get the feature title from the ISO
1461       get_feature_title "$isofile"
1462  
1463       # get the crop value from the ISO
1464       get_crop_from_iso
1465
1466       # check for mplayer dumpstream incompatibilities
1467       # if they exist, this method will set this mode to 0.
1468       check_for_mplayer_dumpstream_incompatibility
1469
1470       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1471
1472         # get our audio id from the ISO file
1473         get_audio_id_from_iso "$isofile"
1474
1475         # create our main VOB file from the ISO
1476         create_main_vob_with_mplayer "$isofile"
1477      
1478         # remove the intermediate VOB file
1479         remove_intermediate_vob_file
1480
1481         # it's possible that our VOB is still corrupted in some manner
1482         # check to make sure it is still a good VOB before continuing.
1483         check_for_mplayer_dumpstream_incompatibility
1484
1485       fi
1486  
1487       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1488
1489         # use dvdbackup to make a DVD folder of the feature title
1490         make_dvdbackup_folder_image
1491   
1492         # create our main VOB file
1493         create_main_vob_with_cat
1494
1495         # get our audio id from the VOB file
1496         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1497   
1498         # check for corrupted VOB start
1499         check_vob_for_corrupted_start
1500  
1501         # check to make sure our VOB is complete
1502         check_vob_for_completeness
1503
1504         # check to make sure our VOB doesn't have too many video packets
1505         check_vob_for_too_many_video_packets
1506
1507         # check to make sure our VOB doesn't have a52 crc errors
1508         check_vob_for_a52_crc_errors
1509
1510         # remove the intermediate VOB file
1511         remove_intermediate_vob_file
1512
1513       fi
1514
1515       # remove the intermediate ISO file
1516       remove_intermediate_iso_file
1517
1518     else
1519       if [ "$encoder" != "handbrake" ]; then 
1520         echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1521         # get our audio id from the VOB file
1522         get_audio_id_from_vob "$vobfile"
1523         # get the crop value from the VOB
1524         get_crop_from_vob
1525       fi
1526     fi
1527
1528     # eject the DVD disk since we are finished with it
1529     [ $eject_disk -eq 2 ] && eject -T $dev
1530
1531     # encode the VOB file to a compressed file format
1532     if [ $make_final_dest_comp -eq 1 ]; then
1533       echo "-> Encoding the DVD video to a compressed file using $encoder" | tee -a "$logfile"
1534
1535       # determine what our bitrate needs to be if a target size was specified instead
1536       calculate_bitrate_from_target_size        
1537      
1538       # encode the vob file into a compressed file format
1539       if [[ "$encoder" == "mencoder" ]]; then 
1540         encode_vob_file_mencoder
1541       fi
1542       if [[ "$encoder" == "handbrake" ]]; then
1543         encode_vob_file_handbrake
1544       fi
1545
1546       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1547         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1548         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1549       else
1550         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1551         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1552       fi
1553     fi
1554
1555   # add this video data to the mythtv DB
1556   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1557   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1558     
1559   else
1560
1561   # use dvdbackup to make a DVD folder of the feature title
1562   make_dvdbackup_folder_image
1563
1564   # cd to the feature title DVD folder
1565   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1566   if [ $? != 0 ]; then
1567     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1568   fi
1569   
1570   # create the dvd.xml file for dvdauthor
1571   create_dvdauthor_dvd_xml_file  
1572
1573   # make the final DVD folder image
1574   make_dvdauthor_folder_image
1575
1576   # add this video data to the mythtv DB
1577   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1578  
1579   # cd back to the dir we started from
1580   popd > /dev/null 2>&1
1581
1582   if [ $make_final_dest_iso -eq 1 ]; then
1583
1584     # make an iso image out of our directory
1585     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1586    
1587     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1588     if [ -s "$dest/$dvdname.iso" ]; then
1589       if [ $make_final_dest_folder -eq 0 ]; then
1590         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1591         # remove the folder of the DVD image now that we have a .iso version of it
1592         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1593       fi
1594     else
1595       # we created an empty iso file, remove it
1596       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1597       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1598       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1599     fi
1600  
1601     # add this video data to the mythtv DB
1602     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1603
1604   fi
1605
1606   fi
1607
1608   # remove the ddrescue DVD ISO image
1609   remove_intermediate_iso_file
1610
1611   # remove the tmp dvdbackup folder of the DVD image
1612   remove_intermediate_dvdbackup_folder
1613
1614   # eject the DVD disk upon completion
1615   [ $eject_disk -eq 1 ] && eject -T $dev
1616
1617   date=`date`
1618   echo "$date DVD rip completed" | tee -a "$logfile"
1619
1620   if [[ -n "$mailto" ]]; then
1621     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1622   fi
1623
1624 fi
1625
1626 ##############################################################################################